//#line 2 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the access_point_control package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __access_point_control__APCONTROLCONFIG_H__
#define __access_point_control__APCONTROLCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace access_point_control
{
  class ApControlConfigStatics;
  
  class ApControlConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(ApControlConfig &config, const ApControlConfig &max, const ApControlConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ApControlConfig &config1, const ApControlConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ApControlConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ApControlConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ApControlConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ApControlConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T ApControlConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (ApControlConfig::* field);

      virtual void clamp(ApControlConfig &config, const ApControlConfig &max, const ApControlConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ApControlConfig &config1, const ApControlConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ApControlConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ApControlConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ApControlConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ApControlConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 10 "../cfg/ApControl.cfg"
      bool enabled;
//#line 12 "../cfg/ApControl.cfg"
      std::string ssid;
//#line 13 "../cfg/ApControl.cfg"
      bool wmm;
//#line 18 "../cfg/ApControl.cfg"
      std::string mode;
//#line 92 "../cfg/ApControl.cfg"
      double freq;
//#line 93 "../cfg/ApControl.cfg"
      bool ieee80211n;
//#line 104 "../cfg/ApControl.cfg"
      std::string encryption_mode;
//#line 105 "../cfg/ApControl.cfg"
      std::string encryption_pass;
//#line 107 "../cfg/ApControl.cfg"
      bool txpower_auto;
//#line 108 "../cfg/ApControl.cfg"
      int txpower;
//#line 124 "../cfg/ApControl.cfg"
      int bitrate;
//#line 130 "../cfg/ApControl.cfg"
      std::string status;
//#line 131 "../cfg/ApControl.cfg"
      std::string errmsg;
//#line 138 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ApControlConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ApControlConfig &__max__ = __getMax__();
      const ApControlConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ApControlConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ApControlConfig &__getDefault__();
    static const ApControlConfig &__getMax__();
    static const ApControlConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const ApControlConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void ApControlConfig::ParamDescription<std::string>::clamp(ApControlConfig &config, const ApControlConfig &max, const ApControlConfig &min) const
  {
    return;
  }

  class ApControlConfigStatics
  {
    friend class ApControlConfig;
    
    ApControlConfigStatics()
    {
//#line 10 "../cfg/ApControl.cfg"
      __min__.enabled = 0;
//#line 10 "../cfg/ApControl.cfg"
      __max__.enabled = 1;
//#line 10 "../cfg/ApControl.cfg"
      __default__.enabled = 0;
//#line 10 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<bool>("enabled", "bool", 1, "Access point running status", "", &ApControlConfig::enabled)));
//#line 12 "../cfg/ApControl.cfg"
      __min__.ssid = "";
//#line 12 "../cfg/ApControl.cfg"
      __max__.ssid = "";
//#line 12 "../cfg/ApControl.cfg"
      __default__.ssid = "test";
//#line 12 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("ssid", "str", 2, "Access point essid (network name)", "", &ApControlConfig::ssid)));
//#line 13 "../cfg/ApControl.cfg"
      __min__.wmm = 0;
//#line 13 "../cfg/ApControl.cfg"
      __max__.wmm = 1;
//#line 13 "../cfg/ApControl.cfg"
      __default__.wmm = 0;
//#line 13 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<bool>("wmm", "bool", 2, "Wireless multimedia extensions support", "", &ApControlConfig::wmm)));
//#line 18 "../cfg/ApControl.cfg"
      __min__.mode = "";
//#line 18 "../cfg/ApControl.cfg"
      __max__.mode = "";
//#line 18 "../cfg/ApControl.cfg"
      __default__.mode = "b";
//#line 18 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("mode", "str", 2, "IEEE 802.11 mode", "{'enum_description': 'Modes supported by the access point', 'enum': [{'srcline': 14, 'description': '802.11a mode', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'a', 'ctype': 'std::string', 'type': 'str', 'name': 'a'}, {'srcline': 15, 'description': '802.11b mode', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'b', 'ctype': 'std::string', 'type': 'str', 'name': 'b'}, {'srcline': 16, 'description': '802.11g mode', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'g', 'ctype': 'std::string', 'type': 'str', 'name': 'g'}]}", &ApControlConfig::mode)));
//#line 92 "../cfg/ApControl.cfg"
      __min__.freq = 0.0;
//#line 92 "../cfg/ApControl.cfg"
      __max__.freq = 100000000000.0;
//#line 92 "../cfg/ApControl.cfg"
      __default__.freq = 2412000000.0;
//#line 92 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<double>("freq", "double", 2, "Access point frequency (Hz)", "{'enum_description': 'IEEE 802.11 channel/frequency list', 'enum': [{'srcline': 20, 'description': 'Channel 1 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2412000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_1_2400MHz'}, {'srcline': 21, 'description': 'Channel 2 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2417000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_2_2400MHz'}, {'srcline': 22, 'description': 'Channel 3 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2422000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_3_2400MHz'}, {'srcline': 23, 'description': 'Channel 4 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2427000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_4_2400MHz'}, {'srcline': 24, 'description': 'Channel 5 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2432000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_5_2400MHz'}, {'srcline': 25, 'description': 'Channel 6 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2437000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_6_2400MHz'}, {'srcline': 26, 'description': 'Channel 7 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2442000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_7_2400MHz'}, {'srcline': 27, 'description': 'Channel 8 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2447000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_8_2400MHz'}, {'srcline': 28, 'description': 'Channel 9 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2452000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_9_2400MHz'}, {'srcline': 29, 'description': 'Channel 10 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2457000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_10_2400MHz'}, {'srcline': 30, 'description': 'Channel 11 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2462000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_11_2400MHz'}, {'srcline': 31, 'description': 'Channel 12 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2467000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_12_2400MHz'}, {'srcline': 32, 'description': 'Channel 13 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2472000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_13_2400MHz'}, {'srcline': 33, 'description': 'Channel 14 // 2.4GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 2484000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_14_2400MHz'}, {'srcline': 34, 'description': 'Channel 131 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3657500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_131_3600MHz'}, {'srcline': 35, 'description': 'Channel 132 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3662500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_132_3600MHz'}, {'srcline': 36, 'description': 'Channel 132 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3660000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_132_3600MHz'}, {'srcline': 37, 'description': 'Channel 133 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3667500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_133_3600MHz'}, {'srcline': 38, 'description': 'Channel 133 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3665000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_133_3600MHz'}, {'srcline': 39, 'description': 'Channel 134 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3672500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_134_3600MHz'}, {'srcline': 40, 'description': 'Channel 134 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3670000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_134_3600MHz'}, {'srcline': 41, 'description': 'Channel 135 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3677500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_135_3600MHz'}, {'srcline': 42, 'description': 'Channel 136 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3682500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_136_3600MHz'}, {'srcline': 43, 'description': 'Channel 136 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3680000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_136_3600MHz'}, {'srcline': 44, 'description': 'Channel 137 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3687500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_137_3600MHz'}, {'srcline': 45, 'description': 'Channel 137 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3685000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_137_3600MHz'}, {'srcline': 46, 'description': 'Channel 138 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3689500000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_138_3600MHz'}, {'srcline': 47, 'description': 'Channel 138 // 3.6GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 3690000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_138_3600MHz'}, {'srcline': 48, 'description': 'Channel 183 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4915000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_183_5000MHz'}, {'srcline': 49, 'description': 'Channel 184 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4920000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_184_5000MHz'}, {'srcline': 50, 'description': 'Channel 185 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4925000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_185_5000MHz'}, {'srcline': 51, 'description': 'Channel 187 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4935000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_187_5000MHz'}, {'srcline': 52, 'description': 'Channel 188 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4940000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_188_5000MHz'}, {'srcline': 53, 'description': 'Channel 189 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4945000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_189_5000MHz'}, {'srcline': 54, 'description': 'Channel 192 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4960000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_192_5000MHz'}, {'srcline': 55, 'description': 'Channel 196 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 4980000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_196_5000MHz'}, {'srcline': 56, 'description': 'Channel 7 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5035000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_7_5000MHz'}, {'srcline': 57, 'description': 'Channel 8 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5040000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_8_5000MHz'}, {'srcline': 58, 'description': 'Channel 9 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5045000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_9_5000MHz'}, {'srcline': 59, 'description': 'Channel 11 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5055000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_11_5000MHz'}, {'srcline': 60, 'description': 'Channel 12 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5060000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_12_5000MHz'}, {'srcline': 61, 'description': 'Channel 16 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5080000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_16_5000MHz'}, {'srcline': 62, 'description': 'Channel 34 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5170000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_34_5000MHz'}, {'srcline': 63, 'description': 'Channel 36 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5180000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_36_5000MHz'}, {'srcline': 64, 'description': 'Channel 38 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5190000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_38_5000MHz'}, {'srcline': 65, 'description': 'Channel 40 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5200000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_40_5000MHz'}, {'srcline': 66, 'description': 'Channel 42 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5210000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_42_5000MHz'}, {'srcline': 67, 'description': 'Channel 44 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5220000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_44_5000MHz'}, {'srcline': 68, 'description': 'Channel 46 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5230000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_46_5000MHz'}, {'srcline': 69, 'description': 'Channel 48 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5240000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_48_5000MHz'}, {'srcline': 70, 'description': 'Channel 52 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5260000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_52_5000MHz'}, {'srcline': 71, 'description': 'Channel 56 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5280000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_56_5000MHz'}, {'srcline': 72, 'description': 'Channel 60 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5300000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_60_5000MHz'}, {'srcline': 73, 'description': 'Channel 64 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5320000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_64_5000MHz'}, {'srcline': 74, 'description': 'Channel 100 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5500000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_100_5000MHz'}, {'srcline': 75, 'description': 'Channel 104 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5520000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_104_5000MHz'}, {'srcline': 76, 'description': 'Channel 108 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5540000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_108_5000MHz'}, {'srcline': 77, 'description': 'Channel 112 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5560000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_112_5000MHz'}, {'srcline': 78, 'description': 'Channel 116 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5580000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_116_5000MHz'}, {'srcline': 79, 'description': 'Channel 120 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5600000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_120_5000MHz'}, {'srcline': 80, 'description': 'Channel 124 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5620000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_124_5000MHz'}, {'srcline': 81, 'description': 'Channel 128 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5640000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_128_5000MHz'}, {'srcline': 82, 'description': 'Channel 132 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5660000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_132_5000MHz'}, {'srcline': 83, 'description': 'Channel 136 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5680000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_136_5000MHz'}, {'srcline': 84, 'description': 'Channel 140 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5700000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_140_5000MHz'}, {'srcline': 85, 'description': 'Channel 149 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5745000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_149_5000MHz'}, {'srcline': 86, 'description': 'Channel 153 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5765000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_153_5000MHz'}, {'srcline': 87, 'description': 'Channel 157 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5785000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_157_5000MHz'}, {'srcline': 88, 'description': 'Channel 161 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5805000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_161_5000MHz'}, {'srcline': 89, 'description': 'Channel 165 // 5GHz', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const double', 'value': 5825000000.0, 'ctype': 'double', 'type': 'double', 'name': 'Channel_165_5000MHz'}]}", &ApControlConfig::freq)));
//#line 93 "../cfg/ApControl.cfg"
      __min__.ieee80211n = 0;
//#line 93 "../cfg/ApControl.cfg"
      __max__.ieee80211n = 1;
//#line 93 "../cfg/ApControl.cfg"
      __default__.ieee80211n = 0;
//#line 93 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<bool>("ieee80211n", "bool", 2, "IEEE 802.11n support", "", &ApControlConfig::ieee80211n)));
//#line 104 "../cfg/ApControl.cfg"
      __min__.encryption_mode = "";
//#line 104 "../cfg/ApControl.cfg"
      __max__.encryption_mode = "";
//#line 104 "../cfg/ApControl.cfg"
      __default__.encryption_mode = "open";
//#line 104 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("encryption_mode", "str", 2, "Security mode", "{'enum_description': 'The types of encryption supported.', 'enum': [{'srcline': 95, 'description': 'no security (open)', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'open', 'ctype': 'std::string', 'type': 'str', 'name': 'open'}, {'srcline': 96, 'description': 'WEP security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wep', 'ctype': 'std::string', 'type': 'str', 'name': 'wep'}, {'srcline': 97, 'description': 'WPA-Personal security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wpa', 'ctype': 'std::string', 'type': 'str', 'name': 'wpa'}, {'srcline': 98, 'description': 'WPA2-Personal security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wpa2', 'ctype': 'std::string', 'type': 'str', 'name': 'wpa2'}, {'srcline': 99, 'description': 'WPA-Enterprise security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wpa_enterprise', 'ctype': 'std::string', 'type': 'str', 'name': 'wpa_enterprise'}, {'srcline': 100, 'description': 'WPA2-Enterprise security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wpa2_enterprise', 'ctype': 'std::string', 'type': 'str', 'name': 'wpa2_enterprise'}, {'srcline': 101, 'description': 'WPA or WPA2 security', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'wpa_wpa2', 'ctype': 'std::string', 'type': 'str', 'name': 'wpa_wpa2'}]}", &ApControlConfig::encryption_mode)));
//#line 105 "../cfg/ApControl.cfg"
      __min__.encryption_pass = "";
//#line 105 "../cfg/ApControl.cfg"
      __max__.encryption_pass = "";
//#line 105 "../cfg/ApControl.cfg"
      __default__.encryption_pass = "";
//#line 105 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("encryption_pass", "str", 2, "Encryption key for WEP or passphrase for WPA", "", &ApControlConfig::encryption_pass)));
//#line 107 "../cfg/ApControl.cfg"
      __min__.txpower_auto = 0;
//#line 107 "../cfg/ApControl.cfg"
      __max__.txpower_auto = 1;
//#line 107 "../cfg/ApControl.cfg"
      __default__.txpower_auto = 1;
//#line 107 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<bool>("txpower_auto", "bool", 4, "Automatic TX power control", "", &ApControlConfig::txpower_auto)));
//#line 108 "../cfg/ApControl.cfg"
      __min__.txpower = 0;
//#line 108 "../cfg/ApControl.cfg"
      __max__.txpower = 30;
//#line 108 "../cfg/ApControl.cfg"
      __default__.txpower = 0;
//#line 108 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<int>("txpower", "int", 4, "TX power (dBm) - set first txpower_auto to False", "", &ApControlConfig::txpower)));
//#line 124 "../cfg/ApControl.cfg"
      __min__.bitrate = -2147483648;
//#line 124 "../cfg/ApControl.cfg"
      __max__.bitrate = 2147483647;
//#line 124 "../cfg/ApControl.cfg"
      __default__.bitrate = 0;
//#line 124 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<int>("bitrate", "int", 8, "TX bitrate (bps)", "{'enum_description': '802.11 bitrates', 'enum': [{'srcline': 110, 'description': 'Auto', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Auto'}, {'srcline': 111, 'description': '1 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 1000000, 'ctype': 'int', 'type': 'int', 'name': '1Mbit'}, {'srcline': 112, 'description': '2 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 2000000, 'ctype': 'int', 'type': 'int', 'name': '2Mbit'}, {'srcline': 113, 'description': '5.5 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 5500000, 'ctype': 'int', 'type': 'int', 'name': '5_5Mbit'}, {'srcline': 114, 'description': '6 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 6000000, 'ctype': 'int', 'type': 'int', 'name': '6Mbit'}, {'srcline': 115, 'description': '9 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 9000000, 'ctype': 'int', 'type': 'int', 'name': '9Mbit'}, {'srcline': 116, 'description': '11 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 11000000, 'ctype': 'int', 'type': 'int', 'name': '11Mbit'}, {'srcline': 117, 'description': '12 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 12000000, 'ctype': 'int', 'type': 'int', 'name': '12Mbit'}, {'srcline': 118, 'description': '18 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 18000000, 'ctype': 'int', 'type': 'int', 'name': '18Mbit'}, {'srcline': 119, 'description': '24 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 24000000, 'ctype': 'int', 'type': 'int', 'name': '24Mbit'}, {'srcline': 120, 'description': '36 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 36000000, 'ctype': 'int', 'type': 'int', 'name': '36Mbit'}, {'srcline': 121, 'description': '48 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 48000000, 'ctype': 'int', 'type': 'int', 'name': '48Mbit'}, {'srcline': 122, 'description': '54 Mbit/s', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const int', 'value': 54000000, 'ctype': 'int', 'type': 'int', 'name': '54Mbit'}]}", &ApControlConfig::bitrate)));
//#line 130 "../cfg/ApControl.cfg"
      __min__.status = "";
//#line 130 "../cfg/ApControl.cfg"
      __max__.status = "";
//#line 130 "../cfg/ApControl.cfg"
      __default__.status = "OK";
//#line 130 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("status", "str", 16, "Status of last parameter update", "{'enum_description': 'Status code', 'enum': [{'srcline': 126, 'description': 'operation successfully completed', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'OK', 'ctype': 'std::string', 'type': 'str', 'name': 'OK'}, {'srcline': 127, 'description': 'last operation failed', 'srcfile': '../cfg/ApControl.cfg', 'cconsttype': 'const char * const', 'value': 'FAIL', 'ctype': 'std::string', 'type': 'str', 'name': 'FAIL'}]}", &ApControlConfig::status)));
//#line 131 "../cfg/ApControl.cfg"
      __min__.errmsg = "";
//#line 131 "../cfg/ApControl.cfg"
      __max__.errmsg = "";
//#line 131 "../cfg/ApControl.cfg"
      __default__.errmsg = "";
//#line 131 "../cfg/ApControl.cfg"
      __param_descriptions__.push_back(ApControlConfig::AbstractParamDescriptionConstPtr(new ApControlConfig::ParamDescription<std::string>("errmsg", "str", 16, "Error message if last update was not successful", "", &ApControlConfig::errmsg)));
//#line 239 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<ApControlConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<ApControlConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    ApControlConfig __max__;
    ApControlConfig __min__;
    ApControlConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const ApControlConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ApControlConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ApControlConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const ApControlConfig &ApControlConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const ApControlConfig &ApControlConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const ApControlConfig &ApControlConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<ApControlConfig::AbstractParamDescriptionConstPtr> &ApControlConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const ApControlConfigStatics *ApControlConfig::__get_statics__()
  {
    const static ApControlConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ApControlConfigStatics::get_instance();
    
    return statics;
  }

//#line 14 "../cfg/ApControl.cfg"
      const char * const ApControl_a = "a";
//#line 15 "../cfg/ApControl.cfg"
      const char * const ApControl_b = "b";
//#line 16 "../cfg/ApControl.cfg"
      const char * const ApControl_g = "g";
//#line 20 "../cfg/ApControl.cfg"
      const double ApControl_Channel_1_2400MHz = 2412000000.0;
//#line 21 "../cfg/ApControl.cfg"
      const double ApControl_Channel_2_2400MHz = 2417000000.0;
//#line 22 "../cfg/ApControl.cfg"
      const double ApControl_Channel_3_2400MHz = 2422000000.0;
//#line 23 "../cfg/ApControl.cfg"
      const double ApControl_Channel_4_2400MHz = 2427000000.0;
//#line 24 "../cfg/ApControl.cfg"
      const double ApControl_Channel_5_2400MHz = 2432000000.0;
//#line 25 "../cfg/ApControl.cfg"
      const double ApControl_Channel_6_2400MHz = 2437000000.0;
//#line 26 "../cfg/ApControl.cfg"
      const double ApControl_Channel_7_2400MHz = 2442000000.0;
//#line 27 "../cfg/ApControl.cfg"
      const double ApControl_Channel_8_2400MHz = 2447000000.0;
//#line 28 "../cfg/ApControl.cfg"
      const double ApControl_Channel_9_2400MHz = 2452000000.0;
//#line 29 "../cfg/ApControl.cfg"
      const double ApControl_Channel_10_2400MHz = 2457000000.0;
//#line 30 "../cfg/ApControl.cfg"
      const double ApControl_Channel_11_2400MHz = 2462000000.0;
//#line 31 "../cfg/ApControl.cfg"
      const double ApControl_Channel_12_2400MHz = 2467000000.0;
//#line 32 "../cfg/ApControl.cfg"
      const double ApControl_Channel_13_2400MHz = 2472000000.0;
//#line 33 "../cfg/ApControl.cfg"
      const double ApControl_Channel_14_2400MHz = 2484000000.0;
//#line 34 "../cfg/ApControl.cfg"
      const double ApControl_Channel_131_3600MHz = 3657500000.0;
//#line 35 "../cfg/ApControl.cfg"
      const double ApControl_Channel_132_3600MHz = 3662500000.0;
//#line 36 "../cfg/ApControl.cfg"
      const double ApControl_Channel_132_3600MHz = 3660000000.0;
//#line 37 "../cfg/ApControl.cfg"
      const double ApControl_Channel_133_3600MHz = 3667500000.0;
//#line 38 "../cfg/ApControl.cfg"
      const double ApControl_Channel_133_3600MHz = 3665000000.0;
//#line 39 "../cfg/ApControl.cfg"
      const double ApControl_Channel_134_3600MHz = 3672500000.0;
//#line 40 "../cfg/ApControl.cfg"
      const double ApControl_Channel_134_3600MHz = 3670000000.0;
//#line 41 "../cfg/ApControl.cfg"
      const double ApControl_Channel_135_3600MHz = 3677500000.0;
//#line 42 "../cfg/ApControl.cfg"
      const double ApControl_Channel_136_3600MHz = 3682500000.0;
//#line 43 "../cfg/ApControl.cfg"
      const double ApControl_Channel_136_3600MHz = 3680000000.0;
//#line 44 "../cfg/ApControl.cfg"
      const double ApControl_Channel_137_3600MHz = 3687500000.0;
//#line 45 "../cfg/ApControl.cfg"
      const double ApControl_Channel_137_3600MHz = 3685000000.0;
//#line 46 "../cfg/ApControl.cfg"
      const double ApControl_Channel_138_3600MHz = 3689500000.0;
//#line 47 "../cfg/ApControl.cfg"
      const double ApControl_Channel_138_3600MHz = 3690000000.0;
//#line 48 "../cfg/ApControl.cfg"
      const double ApControl_Channel_183_5000MHz = 4915000000.0;
//#line 49 "../cfg/ApControl.cfg"
      const double ApControl_Channel_184_5000MHz = 4920000000.0;
//#line 50 "../cfg/ApControl.cfg"
      const double ApControl_Channel_185_5000MHz = 4925000000.0;
//#line 51 "../cfg/ApControl.cfg"
      const double ApControl_Channel_187_5000MHz = 4935000000.0;
//#line 52 "../cfg/ApControl.cfg"
      const double ApControl_Channel_188_5000MHz = 4940000000.0;
//#line 53 "../cfg/ApControl.cfg"
      const double ApControl_Channel_189_5000MHz = 4945000000.0;
//#line 54 "../cfg/ApControl.cfg"
      const double ApControl_Channel_192_5000MHz = 4960000000.0;
//#line 55 "../cfg/ApControl.cfg"
      const double ApControl_Channel_196_5000MHz = 4980000000.0;
//#line 56 "../cfg/ApControl.cfg"
      const double ApControl_Channel_7_5000MHz = 5035000000.0;
//#line 57 "../cfg/ApControl.cfg"
      const double ApControl_Channel_8_5000MHz = 5040000000.0;
//#line 58 "../cfg/ApControl.cfg"
      const double ApControl_Channel_9_5000MHz = 5045000000.0;
//#line 59 "../cfg/ApControl.cfg"
      const double ApControl_Channel_11_5000MHz = 5055000000.0;
//#line 60 "../cfg/ApControl.cfg"
      const double ApControl_Channel_12_5000MHz = 5060000000.0;
//#line 61 "../cfg/ApControl.cfg"
      const double ApControl_Channel_16_5000MHz = 5080000000.0;
//#line 62 "../cfg/ApControl.cfg"
      const double ApControl_Channel_34_5000MHz = 5170000000.0;
//#line 63 "../cfg/ApControl.cfg"
      const double ApControl_Channel_36_5000MHz = 5180000000.0;
//#line 64 "../cfg/ApControl.cfg"
      const double ApControl_Channel_38_5000MHz = 5190000000.0;
//#line 65 "../cfg/ApControl.cfg"
      const double ApControl_Channel_40_5000MHz = 5200000000.0;
//#line 66 "../cfg/ApControl.cfg"
      const double ApControl_Channel_42_5000MHz = 5210000000.0;
//#line 67 "../cfg/ApControl.cfg"
      const double ApControl_Channel_44_5000MHz = 5220000000.0;
//#line 68 "../cfg/ApControl.cfg"
      const double ApControl_Channel_46_5000MHz = 5230000000.0;
//#line 69 "../cfg/ApControl.cfg"
      const double ApControl_Channel_48_5000MHz = 5240000000.0;
//#line 70 "../cfg/ApControl.cfg"
      const double ApControl_Channel_52_5000MHz = 5260000000.0;
//#line 71 "../cfg/ApControl.cfg"
      const double ApControl_Channel_56_5000MHz = 5280000000.0;
//#line 72 "../cfg/ApControl.cfg"
      const double ApControl_Channel_60_5000MHz = 5300000000.0;
//#line 73 "../cfg/ApControl.cfg"
      const double ApControl_Channel_64_5000MHz = 5320000000.0;
//#line 74 "../cfg/ApControl.cfg"
      const double ApControl_Channel_100_5000MHz = 5500000000.0;
//#line 75 "../cfg/ApControl.cfg"
      const double ApControl_Channel_104_5000MHz = 5520000000.0;
//#line 76 "../cfg/ApControl.cfg"
      const double ApControl_Channel_108_5000MHz = 5540000000.0;
//#line 77 "../cfg/ApControl.cfg"
      const double ApControl_Channel_112_5000MHz = 5560000000.0;
//#line 78 "../cfg/ApControl.cfg"
      const double ApControl_Channel_116_5000MHz = 5580000000.0;
//#line 79 "../cfg/ApControl.cfg"
      const double ApControl_Channel_120_5000MHz = 5600000000.0;
//#line 80 "../cfg/ApControl.cfg"
      const double ApControl_Channel_124_5000MHz = 5620000000.0;
//#line 81 "../cfg/ApControl.cfg"
      const double ApControl_Channel_128_5000MHz = 5640000000.0;
//#line 82 "../cfg/ApControl.cfg"
      const double ApControl_Channel_132_5000MHz = 5660000000.0;
//#line 83 "../cfg/ApControl.cfg"
      const double ApControl_Channel_136_5000MHz = 5680000000.0;
//#line 84 "../cfg/ApControl.cfg"
      const double ApControl_Channel_140_5000MHz = 5700000000.0;
//#line 85 "../cfg/ApControl.cfg"
      const double ApControl_Channel_149_5000MHz = 5745000000.0;
//#line 86 "../cfg/ApControl.cfg"
      const double ApControl_Channel_153_5000MHz = 5765000000.0;
//#line 87 "../cfg/ApControl.cfg"
      const double ApControl_Channel_157_5000MHz = 5785000000.0;
//#line 88 "../cfg/ApControl.cfg"
      const double ApControl_Channel_161_5000MHz = 5805000000.0;
//#line 89 "../cfg/ApControl.cfg"
      const double ApControl_Channel_165_5000MHz = 5825000000.0;
//#line 95 "../cfg/ApControl.cfg"
      const char * const ApControl_open = "open";
//#line 96 "../cfg/ApControl.cfg"
      const char * const ApControl_wep = "wep";
//#line 97 "../cfg/ApControl.cfg"
      const char * const ApControl_wpa = "wpa";
//#line 98 "../cfg/ApControl.cfg"
      const char * const ApControl_wpa2 = "wpa2";
//#line 99 "../cfg/ApControl.cfg"
      const char * const ApControl_wpa_enterprise = "wpa_enterprise";
//#line 100 "../cfg/ApControl.cfg"
      const char * const ApControl_wpa2_enterprise = "wpa2_enterprise";
//#line 101 "../cfg/ApControl.cfg"
      const char * const ApControl_wpa_wpa2 = "wpa_wpa2";
//#line 110 "../cfg/ApControl.cfg"
      const int ApControl_Auto = 0;
//#line 111 "../cfg/ApControl.cfg"
      const int ApControl_1Mbit = 1000000;
//#line 112 "../cfg/ApControl.cfg"
      const int ApControl_2Mbit = 2000000;
//#line 113 "../cfg/ApControl.cfg"
      const int ApControl_5_5Mbit = 5500000;
//#line 114 "../cfg/ApControl.cfg"
      const int ApControl_6Mbit = 6000000;
//#line 115 "../cfg/ApControl.cfg"
      const int ApControl_9Mbit = 9000000;
//#line 116 "../cfg/ApControl.cfg"
      const int ApControl_11Mbit = 11000000;
//#line 117 "../cfg/ApControl.cfg"
      const int ApControl_12Mbit = 12000000;
//#line 118 "../cfg/ApControl.cfg"
      const int ApControl_18Mbit = 18000000;
//#line 119 "../cfg/ApControl.cfg"
      const int ApControl_24Mbit = 24000000;
//#line 120 "../cfg/ApControl.cfg"
      const int ApControl_36Mbit = 36000000;
//#line 121 "../cfg/ApControl.cfg"
      const int ApControl_48Mbit = 48000000;
//#line 122 "../cfg/ApControl.cfg"
      const int ApControl_54Mbit = 54000000;
//#line 126 "../cfg/ApControl.cfg"
      const char * const ApControl_OK = "OK";
//#line 127 "../cfg/ApControl.cfg"
      const char * const ApControl_FAIL = "FAIL";
}

#endif // __APCONTROLRECONFIGURATOR_H__
